## dde-control-center 6.1.32

=== dcc-old/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

set(DVERSION "6.0.44" CACHE STRING "define project version")
set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")

set(PROJECT_NAME dde-control-center-old)
project(${PROJECT_NAME}
    VERSION ${DVERSION}
    DESCRIPTION "Deepin Control Center"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dde-control-center"
    LANGUAGES CXX C
)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
option(BUILD_TESTING "UNIT test" OFF)

# INFO:
# plugins can be disabled and their options
# plugin-authentication : DISABLE_AUTHENTICATION
# plugin-update : DISABLE_UPDATE
# plugin-keyboard: DISABLE_LANGUAGE to disable language panel

option(DISABLE_AUTHENTICATION "disable build authentication plugins" OFF)
option(DISABLE_UPDATE "disable build update plugins" OFF)
option(DISABLE_LANGUAGE "disable lanugage settings in control center" OFF)
option(USE_DEEPIN_ZONE "enable special timezone file on deepin" OFF)
option(DISABLE_SOUND_ADVANCED "disable sound advanced settings" OFF)
set(DEEPIN_TIME_ZONE_PATH "/usr/share/dde/zoneinfo/zone1970.tab" CACHE STRING "deepin timezone path")
set(LOCALE_I18N_PATH "/usr/share/i18n/SUPPORTED" CACHE STRING "Supported locale path")

# asan 自己有内存泄露，暂不使用
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    # set(UNITTEST ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Werror=return-type -fno-omit-frame-pointer -Wextra")
    if(ENABLE_ASAN)
        if (CMAKE_CXX_COMPILER_ID MATCHES "GNU"  OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -g")
            set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -g")
            set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
            set(CMAKE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS} -fsanitize=address")
            set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=address")
            add_definitions(-DUSE_ASAN)
        endif()
    endif()
else()
    # generate qm
    execute_process(COMMAND bash "misc/translate_generation.sh"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
    # generate desktop translate
    execute_process(COMMAND bash "misc/translate_ts2desktop.sh"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

if (BUILD_TESTING)
    set(UNITTEST ON)
endif()

set(BUILD_PLUGIN ON)

if (NOT BUILD_PLUGIN)
    set(UNITTEST OFF)
endif()
# GNU 默认

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(UT_COMPILER -fprofile-arcs -ftest-coverage)
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(UT_COMPILER -fprofile-instr-generate -ftest-coverage)
endif()

if (USE_DEEPIN_ZONE)
    add_definitions(-DUSE_DEEPIN_ZONE)
    add_definitions(-DDEEPIN_TIME_ZONE_PATH="${DEEPIN_TIME_ZONE_PATH}")
endif ()

add_definitions(-DLOCALE_I18N_PATH="${LOCALE_I18N_PATH}")

# 增加安全编译参数
ADD_DEFINITIONS(${SAFE_COMPILER})

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(GoogleTest)

if(BUILD_DOCS)
    add_subdirectory(docs)
endif()

set(TRANSLATE_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/dde-control-center/translations" CACHE STRING "Install dir for dde-control-center translate files")

add_definitions(-DTRANSLATE_READ_DIR="${CMAKE_INSTALL_PREFIX}/${TRANSLATE_INSTALL_DIR}")
set(MODULE_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/dde-control-center/modules" CACHE STRING "Install dir for dde-control-center modules")

set(DCC_MODULE_READ_DIR "${MODULE_INSTALL_DIR}" CACHE STRING "Dir to find dde-control-center modules")
add_definitions(-DDCC_DefaultModuleDirectory="${DCC_MODULE_READ_DIR}")

set(LOCALSTATE_READ_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}" CACHE STRING "Dir to find modifiable single-machine data")
add_definitions(-DVARDIRECTORY="${LOCALSTATE_READ_DIR}")
# Find the library
find_package(PkgConfig REQUIRED)
find_package(Dtk COMPONENTS Core Widget DConfig REQUIRED)
find_package(Qt5 COMPONENTS Widgets Network DBus Concurrent Multimedia Svg Test REQUIRED)
find_package(GTest REQUIRED)
find_package(Threads REQUIRED)
# pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()

# dconfig
# file(GLOB DCONFIG_FILES "misc/configs/*.json")
# dtk_add_config_meta_files(APPID org.deepin.dde.control-center BASE misc/configs FILES ${DCONFIG_FILES})
# file(GLOB DCONFIG_FILE_REGION_FORMAT "misc/configs/common/org.deepin.region-format.json")
# dtk_add_config_meta_files(COMMONID true FILES ${DCONFIG_FILE_REGION_FORMAT})

include_directories(
    include
)

set(Test_Libraries
    -lgcov
    Threads::Threads
    GTest::gtest
    Qt::Test
)

#--------------------------interface--------------------------
set(Interface_Name dcc-interface)
file(GLOB_RECURSE Interface_SRCS
    "include/interface/*.h"
    "src/interface/*.cpp"
)
add_library(${Interface_Name} SHARED
    ${Interface_SRCS}
)

set(Interface_Libraries
    Qt::Widgets
    Dtk::Widget
)

target_include_directories(${Interface_Name} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/interface>
)

target_include_directories(${Interface_Name} INTERFACE
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center/>
)

target_link_libraries(${Interface_Name} PUBLIC
    ${Interface_Libraries}
)

set_target_properties(${Interface_Name} PROPERTIES
    VERSION 6
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    EXPORT_NAME DCCInterface
)

# so
install(TARGETS ${Interface_Name}
        EXPORT DdeControlCenterInterfaceTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(EXPORT DdeControlCenterInterfaceTargets
        FILE DdeControlCenterInterfaceTargets.cmake
        NAMESPACE Dde::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
)


#--------------------------dccwidgets library----------------------------
set(Dcc_Widgets_Name dcc-widgets)
file(GLOB_RECURSE Dcc_Widgets_SRCS
    "include/widgets/*.h"
    "src/widgets/*.cpp"
)
add_library(${Dcc_Widgets_Name} SHARED
    ${Dcc_Widgets_SRCS}
)
set(Dcc_Widgets_Includes
    include/widgets
)

set(Dcc_Widgets_Libraries_public
    Dtk::Widget
    Qt::Widgets
    ${Interface_Name}
)

set(Dcc_Widgets_Libraries_private
    Qt::Svg
    Qt::DBus
)

set(Dcc_Widgets_Libraries
    ${Dcc_Widgets_Libraries_public}
    ${Dcc_Widgets_Libraries_private}
)

target_include_directories(${Dcc_Widgets_Name} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/widgets>
)

target_include_directories(${Dcc_Widgets_Name} INTERFACE
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center/>
)

target_link_libraries(${Dcc_Widgets_Name} PUBLIC
    ${Dcc_Widgets_Libraries_public}
)

target_link_libraries(${Dcc_Widgets_Name} PRIVATE
    ${Dcc_Widgets_Libraries_private}
)

set_target_properties(${Dcc_Widgets_Name} PROPERTIES
    VERSION 6
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    EXPORT_NAME DCCWidget
)

# so
install(TARGETS ${Dcc_Widgets_Name}
        EXPORT DdeControlCenterWidgetTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(EXPORT DdeControlCenterWidgetTargets
        FILE DdeControlCenterWidgetTargets.cmake
        NAMESPACE Dde::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
)


#------------------------dccwidgets library test--------------------------
if (UNITTEST)
    set(UT_Dcc_Widgets_Name ut-dcc-widgets)
    file(GLOB_RECURSE UT_Dcc_Widgets_SRCS
        "tests/widgets/*.cpp"
    )
    add_executable(${UT_Dcc_Widgets_Name}
        ${Dcc_Widgets_SRCS}
        ${UT_Dcc_Widgets_SRCS}
    )
    # 用于测试覆盖率的编译条件
    target_compile_options(${UT_Dcc_Widgets_Name} PRIVATE ${UT_COMPILER})
    target_include_directories(${UT_Dcc_Widgets_Name} PUBLIC
        ${Dcc_Widgets_Includes}
    )
    target_link_libraries(${UT_Dcc_Widgets_Name} PRIVATE
        ${Dcc_Widgets_Libraries}
        ${Test_Libraries}
    )
    gtest_discover_tests(${UT_Dcc_Widgets_Name} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
endif()

#--------------------------dde-control-center-Agent--------------------------
set(DCC_AGENT_PREFIX "")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(OLD_DCC_SO_PATH ${PROJECT_BINARY_DIR}/../dcc-old/libdcc-widgets.so)
    set(NEW_DCC_SO_PATH ${PROJECT_BINARY_DIR}/../lib/libdde-control-center.so)
    set(OLD_DCC_PATH ${PROJECT_BINARY_DIR}/../dcc-old/libdde-control-center-old.so)
    set(NEW_DCC_PATH ${PROJECT_BINARY_DIR}/../lib/libdde-control-center-lib.so)
else()
    set(DCC_AGENT_PREFIX "/usr/")
    set(OLD_DCC_SO_PATH ${CMAKE_INSTALL_LIBDIR}/libdcc-widgets.so)
    set(NEW_DCC_SO_PATH ${CMAKE_INSTALL_LIBDIR}/libdde-control-center.so)
    set(OLD_DCC_PATH ${CMAKE_INSTALL_LIBDIR}/dde-control-center/libdde-control-center-old.so)
    set(NEW_DCC_PATH ${CMAKE_INSTALL_LIBDIR}/dde-control-center/libdde-control-center-lib.so)
    set(DCC_TRANSLATE_READ_DIR ${CMAKE_INSTALL_PREFIX}/${DCC_TRANSLATION_INSTALL_DIR})
endif()
add_definitions(-DOLD_DCC_SO_PATH="${DCC_AGENT_PREFIX}${OLD_DCC_SO_PATH}")
add_definitions(-DNEW_DCC_SO_PATH="${DCC_AGENT_PREFIX}${NEW_DCC_SO_PATH}")
add_definitions(-DOLD_DCC_PATH="${DCC_AGENT_PREFIX}${OLD_DCC_PATH}")
add_definitions(-DNEW_DCC_PATH="${DCC_AGENT_PREFIX}${NEW_DCC_PATH}")


set(DCC_Agent dde-control-center-agent)
set(DCCAgent_Name ${DCC_Agent})
file(GLOB DCCAgent_SRCS
    "src/dcc-agent/*.c"
)

add_executable(${DCCAgent_Name}
    ${DCCAgent_SRCS}
)

set_target_properties(${DCCAgent_Name} PROPERTIES
    OUTPUT_NAME dde-control-center
)

install(TARGETS ${DCCAgent_Name} DESTINATION ${CMAKE_INSTALL_BINDIR})

#--------------------------dde-control-center--------------------------
set(Control_Center_Name dde-control-center-old)
file(GLOB_RECURSE Control_Center_SRCS
    "src/frame/*.h"
    "src/frame/*.cpp"
)
list(REMOVE_ITEM Control_Center_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/src/frame/main.cpp")

add_library(${Control_Center_Name} SHARED
    ${Control_Center_SRCS}
    src/frame/main.cpp
)

target_compile_definitions(${Control_Center_Name} PRIVATE CVERSION="${CVERSION}")

set(Control_Center_Libraries
    ${Dcc_Widgets_Name}
    ${Interface_Name}
    Dtk::Widget
    Qt::Widgets
    Qt::DBus
    Qt::Concurrent
)

target_link_libraries(${Control_Center_Name} PRIVATE
    ${Control_Center_Libraries}
)

# bin
install(TARGETS ${Control_Center_Name} DESTINATION ${CMAKE_INSTALL_LIBDIR}/dde-control-center/)

#----------------------------install config------------------------------
# qm files
file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES} DESTINATION ${TRANSLATE_INSTALL_DIR})

#desktop
# install(FILES misc/org.deepin.dde.control-center.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

#service
# configure_file(
#     ${CMAKE_CURRENT_SOURCE_DIR}/misc/org.deepin.dde.ControlCenter1.service.in
#     ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ControlCenter1.service
#     @ONLY)
# install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ControlCenter1.service
#         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dbus-1/services)

# systemd service
if (NOT DEFINED SYSTEMD_USER_UNIT_DIR)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Systemd REQUIRED systemd)
    pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
endif()

# configure_file(
#     ${CMAKE_SOURCE_DIR}/misc/systemd/dde-control-center.service.in
#     ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.control-center.service
#     @ONLY)

# install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.control-center.service
#         DESTINATION ${SYSTEMD_USER_UNIT_DIR})

# dev files
file(GLOB HEADERS "include/*")
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center)
install(DIRECTORY ${HEADERS} DESTINATION ${INCLUDE_INSTALL_DIR})

# configure_package_config_file(misc/DdeControlCenterConfig.cmake.in
#     ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake

=== examples/plugin-example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "example")

find_package(Qt6 COMPONENTS Core LinguistTools REQUIRED) # dcc_handle_plugin_translation中用到LinguistTools的函数
find_package(DdeControlCenter REQUIRED)

file(GLOB_RECURSE PLUGIN_SRCS
        "src/*.cpp"
        "src/*.h"
        # "src/qrc/example.qrc"
)
add_library(${PLUGIN_NAME} MODULE
        ${PLUGIN_SRCS}
)

# target_include_directories(${PLUGIN_NAME} PUBLIC
#     Dde::Control-Center
# )

target_link_libraries(${PLUGIN_NAME} PRIVATE
    Dde::Control-Center # 添加dde-control-center库
    Qt6::Core
)
# 处理插件安装
dcc_install_plugin(NAME ${PLUGIN_NAME} TARGET ${PLUGIN_NAME})
# 处理翻译和安装，如果自己处理翻译，可以不调用该函数
dcc_handle_plugin_translation(NAME ${PLUGIN_NAME} )

=== src/dde-control-center/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

#--------------------------frame--------------------------
set(DCCFrame_Name ${DCC_FRAME_Library})
file(GLOB DCCFrame_SRCS
    "${DCC_PROJECT_ROOT_DIR}/include/*.h"
    "frame/*.cpp"
)

add_library(${DCCFrame_Name} SHARED
    ${DCCFrame_SRCS}
)

find_package(${QT_NS} COMPONENTS QmlModels REQUIRED)
set(DCCFrame_Libraries
    ${DTK_NS}::Gui
    ${QT_NS}::Gui
    ${QT_NS}::Quick
    ${QT_NS}::QmlModelsPrivate
)

target_link_libraries(${DCCFrame_Name} PRIVATE
    ${DCCFrame_Libraries}
)

set_target_properties(${DCCFrame_Name} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    OUTPUT_NAME dde-control-center
    EXPORT_NAME Control-Center
)

install(TARGETS ${DCCFrame_Name}
        EXPORT DdeControlCenterTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center
)

install(EXPORT DdeControlCenterTargets
        FILE DdeControlCenterTargets.cmake
        NAMESPACE Dde::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
)
#--------------------------qml-plugin--------------------------
add_subdirectory(frame/plugin)
#--------------------------dde-control-center--------------------------
set(Control_Center_Name dde-control-center)
file(GLOB Control_Center_SRCS
    "*.h"
    "*.cpp"
)
if (BUILD_DCC_OLD)
    add_library(${Control_Center_Name} SHARED
        ${Control_Center_SRCS}
        qrc/dcc.qrc
    )
    set_target_properties(${Control_Center_Name} PROPERTIES
        OUTPUT_NAME dde-control-center-lib
    )
else()
    add_executable(${Control_Center_Name}
        ${Control_Center_SRCS}
        qrc/dcc.qrc
    )
endif()

target_compile_definitions(${Control_Center_Name} PRIVATE CVERSION="${CMAKE_PROJECT_VERSION}")

target_include_directories(${Control_Center_Name} PRIVATE
    include/interface
    frame
)

set(Control_Center_Libraries
    ${DCC_FRAME_Library}
    ${DTK_NS}::Gui
    ${QT_NS}::Gui
    ${QT_NS}::DBus
    ${QT_NS}::Concurrent
    ${QT_NS}::Quick
)

target_link_libraries(${Control_Center_Name} PRIVATE
    ${Control_Center_Libraries}
)

file(GLOB_RECURSE qmlFiles  "${DCC_PROJECT_ROOT_DIR}/qml/*.*")
add_custom_target(${Control_Center_Name}_qml ALL
    SOURCES ${qmlFiles}
)
add_custom_command(TARGET ${Control_Center_Name}_qml POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy_directory "${DCC_PROJECT_ROOT_DIR}/qml" ${DCC_LIBDIR}
)

file(GLOB_RECURSE DCC_Translation_QML_FILES ${DCC_PROJECT_ROOT_DIR}/qml/*.qml ${DCC_PROJECT_ROOT_DIR}/src/*.qml)
file(GLOB_RECURSE DCC_Translation_SOURCE_FILES ${DCC_PROJECT_ROOT_DIR}/src/*.cpp ${DCC_PROJECT_ROOT_DIR}/src/*.h)
dcc_handle_plugin_translation(NAME ${Control_Center_Name} SOURCE_DIR ${DCC_PROJECT_ROOT_DIR} QML_FILES ${DCC_Translation_QML_FILES} SOURCE_FILES ${DCC_Translation_SOURCE_FILES})
# bin
if (BUILD_DCC_OLD)
    install(TARGETS ${Control_Center_Name} DESTINATION ${DCC_DEBUG_LIBDIR})
else()
    install(TARGETS ${Control_Center_Name} DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()
install(DIRECTORY "${DCC_PROJECT_ROOT_DIR}/qml/" DESTINATION ${DCC_INSTALL_DIR})
#----------------------------install config------------------------------
#desktop
install(FILES ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde.control-center.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

#service
configure_file(
    ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde.ControlCenter1.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ControlCenter1.service
    @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ControlCenter1.service
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dbus-1/services)

# systemd service
if (NOT DEFINED SYSTEMD_USER_UNIT_DIR)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Systemd REQUIRED systemd)
    pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
endif()

configure_file(
    ${CMAKE_SOURCE_DIR}/misc/systemd/dde-control-center.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.control-center.service
    @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.control-center.service
        DESTINATION ${SYSTEMD_USER_UNIT_DIR})

# dev files
file(GLOB HEADERS "${DCC_PROJECT_ROOT_DIR}/include/*")
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center)
install(FILES ${HEADERS} DESTINATION ${INCLUDE_INSTALL_DIR})
if (BUILD_DCC_OLD)
    configure_package_config_file(${DCC_PROJECT_ROOT_DIR}/misc/DdeControlCenterConfigOld.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
        PATH_VARS INCLUDE_INSTALL_DIR
        INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
else()
    configure_package_config_file(${DCC_PROJECT_ROOT_DIR}/misc/DdeControlCenterConfig.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
        PATH_VARS INCLUDE_INSTALL_DIR
        INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
endif()

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfigVersion.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfigVersion.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter)

install(FILES "${DCC_PROJECT_ROOT_DIR}/misc/DdeControlCenterPluginMacros.cmake" DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter)

install(FILES ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde.controlcenter.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)

#dde-grand-search-daemon conf
install(FILES ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde-grand-search.dde-control-center-setting.conf
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/dde-grand-search-daemon/plugins/searcher)

=== src/plugin-authentication/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(pluginName authentication)
file(GLOB_RECURSE authentication_SRCS
    "operation/*.cpp"
    "operation/*.h"
    "operation/qrc/${pluginName}.qrc"
)

add_library(${pluginName} MODULE
    ${authentication_SRCS}
)

pkg_check_modules(DEEPIN_PW_CHECK REQUIRED libdeepin_pw_check)
pkg_check_modules(DaReader REQUIRED dareader)

find_package(PolkitQt6-1)
set(authentication_Libraries
    ${DCC_FRAME_Library}
    ${QT_NS}::DBus
    ${DTK_NS}::Core
    ${DTK_NS}::Gui
    ${QT_NS}::Concurrent
    PolkitQt6-1::Agent
    ${DEEPIN_PW_CHECK_LIBRARIES}
    ${DaReader_LIBRARIES}
)

target_link_libraries(${pluginName} PRIVATE
    ${authentication_Libraries}
)

dcc_install_plugin(NAME ${pluginName} TARGET ${pluginName})

=== src/plugin-dock/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

set(PLUGIN_NAME dock)

file(GLOB_RECURSE Dock_Plugin_SRCS
    "operation/*.cpp"
    "operation/*.hpp"
    "operation/*.h"
    "res/dcc-dock-plugin.qrc" 
)

add_library(${PLUGIN_NAME} MODULE
    ${Dock_Plugin_SRCS}
)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DCC_FRAME_Library}
    ${DTK_NS}::Gui
)

dcc_install_plugin(NAME ${PLUGIN_NAME} TARGET ${PLUGIN_NAME})

=== src/plugin-keyboard/CMakeLists.txt ===
if (BUILD_PLUGIN)
    set(Plugin_Name keyboard)
    file(GLOB_RECURSE keyboard_SRCS
        "operation/*.h"
        "operation/*.cpp"
        "operation/qrc/keyboard.qrc"
    )
    file(GLOB_RECURSE keyboard_qml_SRCS
        "qml/*.qml"
    )
    # pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)
    add_library(${Plugin_Name} MODULE
        ${keyboard_SRCS}
    )

    set(keyboard_Includes
        src/plugin-keyboard/operation
    )
    find_package(PolkitQt6-1 REQUIRED)
    set(keyboard_Libraries
        ${DCC_FRAME_Library}
        ${DTK_NS}::Gui
        ${QT_NS}::DBus
        ${QT_NS}::Gui
        ${QT_NS}::Qml
        PolkitQt6-1::Agent
    )
    target_include_directories(${Plugin_Name} PUBLIC
        ${keyboard_Includes}
    )
    target_link_libraries(${Plugin_Name} PRIVATE
        ${keyboard_Libraries}
    )
    dcc_install_plugin(NAME ${Plugin_Name} TARGET ${Plugin_Name})
    # dcc_handle_plugin_translation(NAME ${Plugin_Name}  QML_FILES ${keyboard_qml_SRCS} SOURCE_FILES ${keyboard_SRCS})
endif()

=== src/plugin-systeminfo/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(SystemInfo_Name systemInfo)
file(GLOB_RECURSE systemInfo_SRCS
    "operation/*.cpp"
    "operation/*.h"
    "operation/qrc/systeminfo.qrc"
)

add_library(${SystemInfo_Name} MODULE
    ${systemInfo_SRCS}
    operation/utils.h
)

set(SystemInfo_Libraries
    ${DCC_FRAME_Library}
    ${QT_NS}::DBus
    ${DTK_NS}::Gui
)

target_link_libraries(${SystemInfo_Name} PRIVATE
    ${SystemInfo_Libraries}
)

dcc_install_plugin(NAME ${SystemInfo_Name} TARGET ${SystemInfo_Name})

=== src/plugin-wacom/CMakeLists.txt ===
if (BUILD_PLUGIN)
    set(wacom_Name wacom)
    file(GLOB_RECURSE wacom_SRCS
        "operation/*.cpp"
        "operation/qrc/wacom.qrc"
    )
    file(GLOB_RECURSE wacom_qml_SRCS
        "qml/*.qml"
    )
    find_package(${QT_NS} COMPONENTS Concurrent REQUIRED COMPONENTS Qml)
    add_library(${wacom_Name} MODULE
        ${wacom_SRCS}
    )

    set(wacom_Includes
        src/plugin-wacom/operation
    )
    set(wacom_Libraries
        ${DCC_FRAME_Library}
        ${DTK_NS}::Gui
        ${QT_NS}::DBus
    )
    target_include_directories(${wacom_Name} PUBLIC
        ${wacom_Includes}
    )
    target_link_libraries(${wacom_Name} PRIVATE
        ${wacom_Libraries}
    )
    dcc_install_plugin(NAME ${wacom_Name} TARGET ${wacom_Name})
endif()

=== debian/changelog ===
dde-control-center (6.1.32) unstable; urgency=medium

  * i18n: Updates for project Deepin Desktop Environment (#2419)
  * chore: remove reginal variants for es language
  * fix: update deepin ID notification for UOS compatibility
  * refactor: add Q_UNUSED macros to unused parameters
  * i18n: Updates for project Deepin Desktop Environment (#2415)

 -- caixiangrong <caixiangrong@uniontech.com>  Mon, 23 Jun 2025 16:58:03 +0800

dde-control-center (6.1.31) unstable; urgency=medium

  * fix: Open all keyboard layouts

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 19 Jun 2025 16:43:03 +0800

dde-control-center (6.1.30) unstable; urgency=medium

  * fix: hide pressure sensitivity settings in mouse mode
  * refactor: reorganize shutdown time signal and handling
  * fix: resolve spacing and font issues in touchpad components
  * fix: adjust spacing and margins in LangsChooserDialog
  * fix: Fix the issue of incomplete text display
  * fix: Block keyboard lock function
  * fix: Fixed text position anomalies
  * fix: resolve button hover effects in MicrophonePage
  * fix: add missing hover effects for shortcut editing buttons
  * fix: Fixed icon exceptions
  * i18n: Translate dde-control-center_en.ts in uk (#2399)
  * fix: Fixed the issue of font display in user groups
  * fix: reduce excessive spacing between list items in LangAndFormat
  * fix: reduce excessive spacing between setting sections in
    TimeAndDate
  * fix: align placeholder text to left in custom NTP server input field
  * i18n: Updates for project Deepin Desktop Environment (#2378)
  * fix: modify opacity slide Min value as 25%.
  * fix: adapt custom server confirm button for screen scaling
  * fix: resolve volume icon hover effect issues in SpeakerPage
  * fix: Fix default display for unnamed Bluetooth
  * fix: resolve play button icon display in sound effects
  * style: reorder member variable initialization

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 19 Jun 2025 10:09:03 +0800

dde-control-center (6.1.29) unstable; urgency=medium

  * fix: Fixed the failure of uploading an avatar
  * fix: Fix activation status not syncing
  * fix: Modify the processing method of the identify window
  * fix: ScheduledShutdownDialog cancel behavior on close
  * fix: standardize icon naming in TimeAndDate component
  * fix: resolve caps lock toggle functionality in keyboard plugin
  * fix: Modify brightness text style
  * fix: hide Touchpad gesture options when disabled
  * fix: Fix search no results
  * fix: The fixed issue is prompt for creating a user with the same name
  * fix: Add notification jump processing
  * fix: resolve editing state issue in Shortcuts component
  * fix: Fixed the display of developer mode
  * i18n: Updates for project Deepin Desktop Environment (#2370)
  * fix: improve RegionsChooserWindow layout and scrolling experience
  * fix: handle empty text input in DateTimeSettingDialog
  * fix: Fixed the issue of user group clicking
  * fix: Modify the height spacing
  * fix: customize spinbox input validation in DateTimeSettingDialog
  * chore: update debian control
  * i18n: Translate dde-control-center_en.ts in zh_TW (#2368)
  * i18n: Updates for project Deepin Desktop Environment (#2363)

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 12 Jun 2025 16:40:40 +0800

dde-control-center (6.1.28) unstable; urgency=medium

  * refactor: migrate RSA encryption to EVP API
  * style: add unused parameter markers and fix member order
  * feat: add battery power state awareness to screensaver
  * fix: add POST_BUILD to custom commands
  * fix: update translation with QuickLogin and Lock Dock
  * fix: Add a user group error message
  * feat: add Lock the height of dock.
  * feat: add quick login.
  * fix: improve caps lock and num lock toggle functionality
  * fix: add disambiguation context for "Medium" copywriting
  * i18n: Updates for project Deepin Desktop Environment (#2352)
  * fix: prevent key sequence recording when edit button is clicked
  * fix: Add a full name error message
  * fix: Fixed the issue that the error message was displayed
  * fix: Fix text length limit
  * fix: adjust text handling in KeyboardLayout component
  * feat: Implement keyboard on/off authentication
  * feat: The mode is not updated when only one screen is switched
  * fix: optimize scrolling experience in Shortcuts component
  * fix: Mask input field copy operations
  * fix: Modify menu translations
  * fix: optimize input field layout and validation in TimeAndDate
  * feat: update moudle translation
  * feat: Implement keyboard on/off function
  * fix: remove redundant displayName properties in sound component
  * fix: Fixed the issue of the background color of the list item hover
  * fix: Optimized the focus of the user group list
  * fix: optimize volume control step size for better usability
  * fix: improve deepinid plugin initialization and activation logic
  * i18n: Updates for project Deepin Desktop Environment (#2329)
  * fix: Modifying desktop display without options issue
  * i18n: Updates for project Deepin Desktop Environment (#2326)

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 05 Jun 2025 21:38:17 +0800

dde-control-center (6.1.27) unstable; urgency=medium

  * fix: Edit compilation warning
  * fix: Modify the style of the ComboBox
  * fix: Modify confirmation window coordinate error
  * fix: Fixed the computer name error message
  * chore: use day name from Locale.standaloneDayName()
  * fix: Modify duplicate settings issue
  * fix: enhance clear button UI and padding in TimeAndDate
  * fix: Fixed the issue that Bluetooth did not refresh automatically
  * fix: Add password hint restrictions
  * fix: Duplicate applications can be added in the default program
  * fix: improve text visibility in TimeAndDate component
  * fix: resolve con loading in LangsChooserDialog
  * feat: Add URL fuzzy matching function
  * fix: resolve shortcut conflicts by adding type parameter


=== debian/control ===
Source: dde-control-center
Section: admin
Priority: optional
Maintainer: Deepin Sysdev <sysdev@deepin.com>
Build-Depends:
 debhelper-compat (= 12),
 pkg-config,
 cmake,
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-tools-dev,
 qt6-declarative-private-dev,
 qt6-multimedia-dev,
 libpolkit-qt6-1-dev,
 libdtkcommon-dev,
 libdtk6gui-dev(>=6.0.21),
 libdtk6core-dev,
 libdtk6core-bin,
 doxygen,
 libgtest-dev,
 extra-cmake-modules,
 libqt6svg6,
 deepin-gettext-tools,
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-window,
 qml6-module-qt-labs-qmlmodels,
 qt6-wayland-dev,
 qt6-wayland-private-dev,
 qt6-wayland-dev-tools,
 treeland-protocols(>=0.4.1),
 systemd,
 libdareader-dev,
 libdeepin-pw-check-dev,
 libicu-dev,
 libwayland-dev,
 libssl-dev,
 libdde-shell-dev(>= 1.99.20),
 libdpkg-dev
Standards-Version: 4.5.0
Homepage: https://github.com/linuxdeepin/dde-control-center

Package: dde-control-center
Architecture: any
Depends:
 ${shlibs:Depends}, ${misc:Depends},
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-window,
 qml6-module-qt-labs-qmlmodels,
 qml6-module-qtquick-dialogs,
 libdtk6declarative,
 netselect,
Conflicts: dde-control-center-dock
Replaces: dde-control-center-dock
Description: New control center for Deepin Desktop Environment,
 Integrated control center with rich functions,Besides providing rich
 system setting items, the function level is simple, the logic is clear,
 the user can easily set the system, and the learning cost is low,
 Provide users with automatic update system and developer mode to meet
 the various needs of users for the operating system.
 abrecovery -restore system, Determine whether the system is restored
 reboot-reminder-dialog -Update restart, Confirm whether to restart the system
 after the completion of the update.
 DDE Control Center is the control panel of Deepin Desktop Environment.

Package: dde-control-center-dev
Architecture: any
Depends: dde-control-center (= ${binary:Version}), ${misc:Depends}
Description: New control center for Deepin Desktop Environment - development files
 DDE Control Center is the control panel of Deepin Desktop Environment.

Package: dde-control-center-doc
Architecture: any
Depends: dde-control-center (= ${binary:Version}), ${misc:Depends}
Description: dde-control-center (document)
 This package contains the doc files of dde-control-center
